#ifndef _aviutil_h
#define _aviutil_h
#include <config.h>
#include <string>
using namespace std;

#ifdef USE_TSC
inline unsigned int localcount()
{
    int a;
    __asm__ __volatile__("rdtsc\n\t"
    :"=a"(a)
    :
    :"edx");
    return a;
}
inline long long longcount()
{
    unsigned int i;
    unsigned int j;
    __asm__ __volatile__("rdtsc\n\t":"=a"(i), "=d"(j):);
    return ((long long)j<<32)+(long long)i;
}
#else
#include <sys/time.h>
#include <unistd.h>
inline unsigned int localcount()
{
    struct timeval tv;
    unsigned limit=~0;
    limit/=1000000;
    gettimeofday(&tv, 0);
    return limit*tv.tv_usec;
}
inline long long longcount()
{
    struct timeval tv;
    unsigned limit=~0;
    limit/=1000000;
    gettimeofday(&tv, 0);
    unsigned long long result;
    result=tv.tv_sec;
    result<<=32;
    result+=limit*tv.tv_usec;
    return result;
}
#endif
class CPU_Freq
{
    double freq;
public:
    CPU_Freq();
    operator double() const {return freq;}
};

extern CPU_Freq freq;

inline float to_float(long long t2, long long t1)
{
    long long qw=t2-t1;
    qw=(long long)(qw/freq);//milliseconds;
    return ((int)qw)/1000.;
}

namespace Registry
{
    int WriteInt(string appname, string valname, int value);
    int ReadInt(string appname, string valname, int def_value);
    int WriteFloat(string appname, string valname, float value);
    float ReadFloat(string appname, string valname, float def_value);
    int WriteString(string appname, string valname, string value);
    string ReadString(string appname, string valname, string def_value);
    int WriteData(string appname, string valname, const void* data, int size);
    int ReadData(string appname, string valname, void* data, int size);
};
#endif
